
//To Do:
//Done: Add USB use detection so it would not shutdown after time out while connected to power.
//Done: added  FX Chrono battery value display
//add menu item to turn off LED by user, or stop blinking
//make poweroff interval user selectable:  3 min, 5 min, 10 min, 30min, Never


//THIS SOFTWARE BELOW NOT TO BE USED FOR COMMERICAL GAIN, SALE, OR PURPOSES.
//There is no warranty or liability of any kind whatsoever from the use of this code.  Use it at your wn risk.

/*
*******************************************************************************
* Copyright (c) 2021 by M5Stack
*                  Equipped with M5StickC-Plus sample source code
*                         M5StickC-Plus 
*adapted by DaystateRebel and Fe7565
*******************************************************************************
*/
//Can only call up Menu ONLY AFTER once connected to FX Chrono
//the BLE scan process is code blocking, so can only flas LED about 5sec ON/OFF and buttons may not respond at all.  So must connect to BLE (or cancel/stop) first to let the program flow and all sensors work
//Side-button "Power": press for 2 sec to turn ON, 6 sec to turn OFF  Next to it on front is large Button A : pin 37   Button B (side-button) for Menu : pin 39

//To do:
// - ability to turn off built-in LED via user menu to save battery and too bright (it now stay on lit if "disconnected")
// - ability to set MENU before connecting? right now cannot select Menu unless connected first
// - display flip for M5Stick Plus:  1 = horiz, front button on right;  3 = horiz, front button on Left   2:  display vertical    4: vetical upside down
// - "Power save/Sleep" needs tweaking.
//  - Need refresh Client battery display on LCD.  Looks like it only populates value once connected, but its volatile

//LCD  1.14"   135x240 Driver: ST7789v2      first number is horizontal cursor, second is vertical exp:  60,0
// the M5StickC Plus has 3 buttons. Side-button "Power": press for 2 sec to turn ON, 6 sec to turn OFF  Next to it on front is large Button A : pin 37   Button B (side-button): pin 39
//buzzer is pin 2 (barely audible, use 3000hz)
//IR LED transmitter pin 9
//Red built-in LED is pin 10
//TFT pin break out: MOSI 15; CLK 13; DC 23; RST 18; CS 5
//MICROPHONE -   CLK 0 ; DATA 34
//IMU SCL 22; SDA 21
//Power Mnmgt IC  SCL 22; SDA 21
//according to the schematic the power button only is connected to the AXP192 and not to an ESP32 GPIO as are buttons A and B. Luckily the AXP192 can be setup to detect the power button short / long press via interrupt.
//Checkout the AXP192 datasheet - you can find it here. The AXP192 registers dealing with short / long power button press interrupts are 0x42 (IRQ enable 3) and 0x46 (IRQ status 3).
//Auto-shutdwon after time-out is used in BLE-scan status (user can selet) (To Do); and in connected to BLE status button presses and shot-data will determine when to time out for power off

#include <Arduino.h>
#include "BLEDevice.h"
#include "OneButton.h"
#include <EEPROM.h>
#include <esp_sleep.h>
#include <M5StickCPlus.h>
//#include <M5Stack.h>
#include "AXP192.h"

TFT_eSprite tftSprite = TFT_eSprite(&M5.Lcd);

#define EEPROM_SIZE 5

//using large front Button on pin 37 aka "BtnA" for Menu, and Side button aka Button B (BtnB) pin 39 for soft reboot with ESP.restart() command
#define PIN_INPUT 37  //This is Button A (BtnA) //9 Atom Lite   /37 M5StickC Plus-----button   for others use 0

#define PIN_LED 10                          //27 Atom Lite
int ledState = HIGH;                        //normally ON if HIGH
volatile unsigned long currentMillis;       // blink withhout delay while waiting to connect (no code blocking)
volatile unsigned long interval = 100;      //used to flas LED. Because of BLE scan process, even if this is a non-blocking code, it executes slowly at about 5 sec ON and 5 sec OFF
volatile unsigned long startMillis = 0;     //used for Timer for LED, "no-delay" delay, does not block code
volatile unsigned long currentMillisRun;    // Time since running: reset after each button press AND shot-read then if exceeds interval it will trigger shutdown
volatile unsigned long startMillisRun = 0;  //used for shutdown calcs, "no-delay" delay, does not block code
volatile int poweroffInterval = 300000;     //5 mins, should be menu adjustable by user, FX Chrno times out after 3 mins
volatile float vBattery;                    // client battery stats
volatile float clientBat;                   //client bat save value
int ButtonA = 0;                            //same as PIN_INPUT

OneButton button(PIN_INPUT, true);

#define UNITS_IMPERIAL 0
#define UNITS_METRIC 1
#define UNITS_MAX 1

#define PROFILE_BOW_AIRSOFT 0
#define PROFILE_CO2_PISTOL 1
#define PROFILE_AIR_PISTOL 2
#define PROFILE_AIR_GUN_UK 3
#define PROFILE_AIR_GUN_FAC 4
#define PROFILE_MAX 4

#define DISPLAY_FLIP_OFF 0
#define DISPLAY_FLIP_ON 1
#define DISPLAY_FLIP_MAX 1

#define SENSITIVITY_MAX 100

#define STATE_IDLE 0
#define STATE_CONNECTING 1
#define STATE_CONNECTED 2
#define STATE_READY 3

//#define TFT_GREY 0x5AEB // New color
int brightness = 255;  //0-255 range   (very small difference in power use)

#define seconds() (millis() / 1000)

static uint8_t state = STATE_IDLE;

// The remote service we wish to connect to.
static BLEUUID deviceUUID("0000180a-0000-1000-8000-00805f9b34fb");

static BLEUUID serviceUUID("00001623-88EC-688C-644B-3FA706C0BB75");

// The characteristic of the remote service we are interested in.
static const char* charUUIDs[] = {
  "00001624-88EC-688C-644B-3FA706C0BB75",
  "00001625-88EC-688C-644B-3FA706C0BB75",
  "00001626-88EC-688C-644B-3FA706C0BB75",
  "00001627-88EC-688C-644B-3FA706C0BB75",
  "00001628-88EC-688C-644B-3FA706C0BB75",
  "00001629-88EC-688C-644B-3FA706C0BB75",
  "0000162A-88EC-688C-644B-3FA706C0BB75"
};

static BLERemoteCharacteristic* pRemoteCharacteristic;
static BLEAdvertisedDevice* myDevice;
static BLEClient* pClient;

static bool renderMenu = false;
static bool dirty = false;
static bool profile_changed = false;
static bool power_saving = false;
static unsigned long display_on_at = 0;
static uint8_t searching_ctr = 0;

static uint8_t sensitivity = 50;
static uint8_t units = UNITS_IMPERIAL;
static uint8_t profile = PROFILE_AIR_GUN_FAC;
static uint8_t display_flip = 1;  //  3 for front button on Left, 1 for front button on right
static uint8_t power_save_duration = 0;

static uint32_t shot_count = 0;

typedef void (*menuItemCallback_t)(uint8_t);
typedef void (*menuItemGenString_t)(char*);

typedef struct menuItem {
  const char* menuString;
  menuItemGenString_t menuItemGenString;
  struct menuItem* nextMenuItem;
  struct menuItem* currentSubMenu;
  struct menuItem* subMenu;
  menuItemCallback_t menuItemCallback;
  uint8_t param;
  menuItemGenString_t menuItemGenCurSelString;
} menuItem_t;

static menuItem_t* menuStack[4];
static int menuStackIndex;
static menuItem_t* pCurrentMenuItem;

///////////////////////////////////////////////////////////////////////////////////SET UP STARTS//////////////////////////////////////
void setup() {
  Serial.begin(115200);
  Serial.println("Starting To Open Display...");

  startMillis = millis();
  startMillisRun = millis();  // Time since running, used to trigger shutdown

  M5.begin();  // Initialize M5StickC Plus LCD
  //M5.update();
  M5.Axp.begin();                    //????
  M5.Lcd.setTextWrap(true);          //wrap both x and y axis
  M5.Lcd.setTextSize(3);             // Set font size.
  M5.Lcd.setRotation(display_flip);  // Rotate the screen  3=> front button on left. The rotation angle is a multiple of 90° 0 to 3 rotate clockwise, 4 to 7 rotate counterclockwise (default is 1)   Need to be set before display

  tftSprite.createSprite(240, 135);  // Create a 240x135 canvas.
  tftSprite.setRotation(display_flip);
  M5.Axp.EnableCoulombcounter();
  M5.Axp.ScreenBreath(brightness);  //screen brightness (values 7-15????)
  
  button.attachDoubleClick(doubleClick);
  button.attachLongPressStop(longPressStop);
  button.attachClick(singleClick);

  pinMode(PIN_LED, OUTPUT);
  digitalWrite(PIN_LED, LOW);

  /*
 * Read the Settings, if any setting is out of range
 * give it a sensible default value (cope with first use)
 */
  EEPROM.begin(EEPROM_SIZE);
  sensitivity = EEPROM.read(0);
  if (sensitivity > SENSITIVITY_MAX) {
    sensitivity = 30;
    EEPROM.write(0, sensitivity);
  }
  units = EEPROM.read(1);
  if (units > UNITS_MAX) {
    units = UNITS_MAX;
    EEPROM.write(1, units);
  }
  profile = EEPROM.read(2);
  if (profile > PROFILE_MAX) {
    profile = PROFILE_MAX;
    EEPROM.write(2, profile);
  }
  display_flip = EEPROM.read(3);
  if (display_flip > DISPLAY_FLIP_MAX) {
    display_flip = 3;
    EEPROM.write(3, display_flip);
  }
  power_save_duration = EEPROM.read(4);
  if (power_save_duration > 10) {
    power_save_duration = 10;
    EEPROM.write(4, power_save_duration);
  }
  EEPROM.commit();

  BLEDevice::init("");
}
////////////////////////////////////////////////////////////////////////////////END OF SETUP//////////////////////////////
void doRenderMenu() {
  char genHeader[16];
  M5.Lcd.fillScreen(BLACK);

  const char* pHeadertxt;
  if (pCurrentMenuItem->menuItemGenString == NULL) {
    pHeadertxt = pCurrentMenuItem->menuString;

  } else {
    pHeadertxt = genHeader;
    pCurrentMenuItem->menuItemGenString(genHeader);
  }
  //M5.update();
  M5.Lcd.setTextColor(WHITE);
  M5.Lcd.setTextSize(2);
  M5.Lcd.setCursor(70, 35);
  M5.Lcd.print(pHeadertxt);

  const char* psubHeadertxt = pCurrentMenuItem->currentSubMenu->menuString;
  if (psubHeadertxt == NULL) {
    psubHeadertxt = genHeader;
    pCurrentMenuItem->currentSubMenu->menuItemGenString(genHeader);
  }

  M5.Lcd.setTextColor(WHITE);
  M5.Lcd.setTextSize(2);
  M5.Lcd.setCursor(30, 65);
  M5.Lcd.print(psubHeadertxt);

  const char* pcurSelHeadertxt;
  if (pCurrentMenuItem->currentSubMenu->menuItemGenCurSelString) {
    pcurSelHeadertxt = genHeader;
    pCurrentMenuItem->currentSubMenu->menuItemGenCurSelString(genHeader);

    M5.Lcd.setTextColor(WHITE);
    M5.Lcd.setTextSize(2);
    M5.Lcd.setCursor(30, 95);
    M5.Lcd.print(pcurSelHeadertxt);
  }
}

#define STR_SEARCHING "Searching"

void renderSearching() {


  if (currentMillis - startMillis > interval) {  //LED blink timer only, not to use with power off timer
    startMillis = currentMillis;                 //
    ledState = !ledState;                        // "toggles" the state
    digitalWrite(PIN_LED, ledState);
  }

  //display "Searching" on LCD
//  M5.update();
  M5.Lcd.fillScreen(BLACK);
  M5.Lcd.fillCircle(15, 15, 15, RED);

  M5.Lcd.setTextColor(WHITE);
  M5.Lcd.setTextSize(3);
  M5.Lcd.setCursor(20, 57);
  M5.Lcd.print("Searching...");

  M5.Lcd.setTextColor(ORANGE);
  M5.Lcd.setTextSize(2);
  M5.Lcd.setCursor(35, 100);
  M5.Lcd.print("Turn ON chrono");
 
  pressBtnPower();
}

class MyAdvertisedDeviceCallbacks : public BLEAdvertisedDeviceCallbacks {
  /**
   * Called for each advertising BLE server.
   */
  void onResult(BLEAdvertisedDevice advertisedDevice) {
    Serial.println(advertisedDevice.toString().c_str());
    // We have found a device, let us now see if it contains the service we are looking for.
    if (advertisedDevice.haveServiceUUID() && advertisedDevice.isAdvertisingService(deviceUUID)) {
      Serial.println("Found My Little Chrony");
      BLEDevice::getScan()->stop();
      myDevice = new BLEAdvertisedDevice(advertisedDevice);
      state = STATE_CONNECTING;
    }  // Found our server
  }    // onResult
};     // MyAdvertisedDeviceCallbacks

void do_scan() {
  BLEScan* pBLEScan = BLEDevice::getScan();
  pBLEScan->setAdvertisedDeviceCallbacks(new MyAdvertisedDeviceCallbacks());
  pBLEScan->setInterval(1349);
  pBLEScan->setWindow(449);
  pBLEScan->setActiveScan(true);
  pBLEScan->start(5, false);
}

bool writeChar(BLERemoteService* pRemoteService, int idx, uint8_t value) {
  // Obtain a reference to the characteristic in the service of the remote BLE server.
  pRemoteCharacteristic = pRemoteService->getCharacteristic(charUUIDs[idx]);
  if (pRemoteCharacteristic == nullptr) {
    Serial.print("Failed to find our characteristic UUID: ");
    Serial.println(charUUIDs[idx]);
    return false;
  }

  // Read the value of the characteristic.
  if (pRemoteCharacteristic->canWrite()) {
    pRemoteCharacteristic->writeValue(&value, 1);
  }
  Serial.printf(" - Wrote to characteristic %s value %X OK", charUUIDs[idx], value);

  return true;
}

bool readChar(BLERemoteService* pRemoteService, int idx, uint8_t* value) {
  // Obtain a reference to the characteristic in the service of the remote BLE server.
  pRemoteCharacteristic = pRemoteService->getCharacteristic(charUUIDs[idx]);
  if (pRemoteCharacteristic == nullptr) {
    Serial.print("Failed to find our characteristic UUID: ");
    Serial.println(charUUIDs[idx]);
    return false;
  }

  // Read the value of the characteristic.
  if (pRemoteCharacteristic->canRead()) {
    std::string v = pRemoteCharacteristic->readValue();
    *value = v[0];
  }
  Serial.println(" - Read from characteristic OK");
  return true;
}


bool readBattery(BLERemoteService* pRemoteService) {
  uint8_t vb;
  if (!readChar(pRemoteService, 3, &vb)) {
    return false;
  }
  float vBattery = (vb * 20.0) / 1000;
  Serial.printf(" - FX Chrono %f v\n", vBattery);
  Serial.print("FX Chrono %: ");
  Serial.println(vBattery);
  if (vBattery > 0) {
    clientBat = vBattery;
  }
  //M5.update();
  M5.Lcd.setTextSize(2);
  M5.Lcd.setTextColor(WHITE);
  M5.Lcd.setCursor(180, 18);

  if (clientBat > 0) {
    M5.Lcd.printf("%.2fv", clientBat);  //FX Chrono battery,  (refresh every 3 mins?)
  }

  return true;
}


class MyClientCallback : public BLEClientCallbacks {
  void onConnect(BLEClient* pclient) {
    Serial.println(" Connected to Chrony ");
  }

  void onDisconnect(BLEClient* pclient) {
    state = STATE_IDLE;
    dirty = true;
    renderMenu = false;
    Serial.println("Disconnected!");
  }
};


static void notifyCallback(
  BLERemoteCharacteristic* pBLERemoteCharacteristic,
  uint8_t* pData,
  size_t length,
  bool isNotify) {
  char sbuffer[16];

  //Serial.print("Notify callback for characteristic ");
  // Third byte is return in steps of 5%, anything better than 10% we display
  uint8_t r = ((char*)pData)[2] * 5;
  uint16_t speed;
  if ((r >= sensitivity) && !renderMenu) {
    display_on_at = seconds();
    power_saving = false;

   // M5.Lcd.setCursor(0, 50);
   // M5.Lcd.printf("shoot main loop");

    renderMenu = false;
    shot_count++;

    startMillisRun = currentMillisRun;  //if shot received, resets power off timer
    Serial.print(startMillisRun = currentMillisRun);
    Serial.println("<= time elapsed since last shot received");

    Serial.print(pBLERemoteCharacteristic->getUUID().toString().c_str());
    Serial.print(" of data length ");
    Serial.println(length);
    Serial.print("data: ");
    Serial.printf("%02X %02X %02X\n", ((char*)pData)[0], ((char*)pData)[1], ((char*)pData)[2]);

    speed = ((char*)pData)[0];
    speed <<= 8;
    speed |= ((char*)pData)[1];

    float fspeed = speed;

    if (units == UNITS_IMPERIAL) {
      fspeed *= 0.0475111859;
      sprintf(sbuffer, "%dfps", int(fspeed));
      Serial.print("Velocity: ");
      Serial.println(sbuffer);


M5.Axp.begin();
      //M5.update();
      M5.Lcd.fillScreen(BLACK);
      M5.Lcd.setTextColor(GREEN);
      M5.Lcd.setTextSize(2);
      M5.Lcd.setCursor(50, 0);
      M5.Lcd.print("Connected");
      M5.Lcd.fillCircle(15, 15, 15, GREEN);

      M5.Lcd.setTextSize(2);
      M5.Lcd.setCursor(180, 0);
      M5.Lcd.setTextColor(WHITE);
      M5.Lcd.printf("%.2fv", M5.Axp.GetBatVoltage());
      M5.Lcd.setCursor(180, 18);
      //M5.Lcd.printf("%.2fv",clientBat) ;//FX Chrono battery,  (refresh every 3 mins?)
      if (clientBat > 0) {
        M5.Lcd.printf("%.2fv", clientBat);  //FX Chrono battery,  (refresh every 3 mins?)
      }
     // M5.Lcd.setCursor(0, 50);
      //M5.Lcd.printf("shoot fps loop");

      M5.Lcd.setTextColor(WHITE);
      M5.Lcd.setTextSize(10);
      M5.Lcd.setCursor(56, 38);
      M5.Lcd.print(fspeed, 0);
      M5.Lcd.setTextSize(2);
      M5.Lcd.setCursor(196, 68);
      M5.Lcd.setTextColor(ORANGE);
      M5.Lcd.print("fps");


    } else {
      fspeed *= 0.014481409;
      sprintf(sbuffer, "%dm/s", int(fspeed));
      Serial.print("Velocity: ");
      Serial.println(sbuffer);

M5.Axp.begin();
      // M5.update();
      M5.Lcd.fillScreen(BLACK);
      M5.Lcd.setTextColor(GREEN);
      M5.Lcd.setTextSize(2);
      M5.Lcd.setCursor(50, 0);
      M5.Lcd.print("Connected");
      M5.Lcd.fillCircle(15, 15, 15, GREEN);

      M5.Lcd.setTextSize(2);
      M5.Lcd.setCursor(180, 0);
      M5.Lcd.setTextColor(WHITE);
      M5.Lcd.printf("%.2fv", M5.Axp.GetBatVoltage());
      M5.Lcd.setCursor(180, 18);
      //M5.Lcd.printf("%.2fv",clientBat) ;//FX Chrono battery,  (refresh every 3 mins?)
      if (clientBat > 0) {
        M5.Lcd.printf("%.2fv", clientBat);  //FX Chrono battery,  (refresh every 3 mins?)
      }
     // M5.Lcd.setCursor(0, 50);
     // M5.Lcd.printf("shoot m/s loop");

      M5.Lcd.setTextColor(WHITE);
      M5.Lcd.setTextSize(10);
      M5.Lcd.setCursor(56, 38);
      M5.Lcd.print(fspeed, 0);
      M5.Lcd.setTextSize(2);
      M5.Lcd.setCursor(196, 68);
      M5.Lcd.setTextColor(ORANGE);
      M5.Lcd.print("m/s");
    }

    sprintf(sbuffer, "Shot %d", shot_count);
    M5.Lcd.setTextSize(2);
    M5.Lcd.setCursor(2, 115);
    M5.Lcd.setTextColor(ORANGE);
    M5.Lcd.print("Shot# ");
    M5.Lcd.setTextSize(3);
    M5.Lcd.setCursor(75, 110);
    M5.Lcd.setTextColor(WHITE);
    M5.Lcd.print(shot_count);
    // M5.Lcd.print("999");

    sprintf(sbuffer, "Return %d%%", r);
    M5.Lcd.setTextSize(2);
    M5.Lcd.setCursor(157, 115);
    M5.Lcd.setTextColor(ORANGE);
    M5.Lcd.print("R%: ");
    M5.Lcd.setTextSize(2);
    M5.Lcd.setCursor(200, 115);
    M5.Lcd.setTextColor(WHITE);
    M5.Lcd.print(r);
  }
}

uint8_t profile_bytes[2][5] = { { 0x32, 0x32, 0x32, 0x32, 0x64 }, { 0x17, 0x1E, 0x2D, 0x43, 0x5A } };

//151-462

void connectToChrony() {
  Serial.print("Forming a connection to ");
  Serial.println(myDevice->getAddress().toString().c_str());

  pClient = BLEDevice::createClient();
  Serial.println(" - Created client");

  pClient->setClientCallbacks(new MyClientCallback());

  // Connect to the remove BLE Server.
  pClient->connect(myDevice);  // if you pass BLEAdvertisedDevice instead of address, it will be recognized type of peer device address (public or private)
  Serial.println(" - Connected to server");
  M5.Lcd.fillScreen(BLACK);
  M5.Lcd.setTextColor(GREEN);
  M5.Lcd.setTextSize(2);
  M5.Lcd.setCursor(50, 0);
  M5.Lcd.print("Connected");
  M5.Lcd.fillCircle(15, 15, 15, GREEN);

  M5.Lcd.setTextSize(2);
  M5.Lcd.setCursor(180, 0);
  M5.Lcd.setTextColor(WHITE);
  M5.Lcd.printf("%.2fv", M5.Axp.GetBatVoltage());
  M5.Lcd.setCursor(180, 18);
  //M5.Lcd.printf("%.2fv",clientBat) ;//FX Chrono battery,  (refresh every 3 mins?)
  if (clientBat > 0) {
    M5.Lcd.printf("%.2fv", clientBat);  //FX Chrono battery,  (refresh every 3 mins?)
  }
 // M5.Lcd.setCursor(0, 50);
  //M5.Lcd.printf("connected to server loop");

  pClient->setMTU(517);  //set client to request maximum MTU from server (default is 23 otherwise)

  // Obtain a reference to the service we are after in the remote BLE server.
  BLERemoteService* pRemoteService = pClient->getService(serviceUUID);
  if (pRemoteService == nullptr) {
    Serial.print("Failed to find our service UUID: ");
    Serial.println(serviceUUID.toString().c_str());
    pClient->disconnect();
    dirty = true;
    state = STATE_IDLE;
    return;
  }
  Serial.println(" - Found our service");

  if (!writeChar(pRemoteService, 2, profile_bytes[0][profile])) {
    pClient->disconnect();
    dirty = true;
    state = STATE_IDLE;
    return;
  }
  if (!writeChar(pRemoteService, 4, profile_bytes[1][profile])) {
    pClient->disconnect();
    dirty = true;
    state = STATE_IDLE;
    return;
  }
  Serial.println(" - Profile Set");

  if (!readBattery(pRemoteService)) {
    pClient->disconnect();
    dirty = true;
    state = STATE_IDLE;
    return;
  }

  pRemoteCharacteristic = pRemoteService->getCharacteristic(charUUIDs[0]);
  if (pRemoteCharacteristic == nullptr) {
    Serial.print("Failed to find our characteristic UUID: ");
    Serial.println(charUUIDs[0]);
    pClient->disconnect();
    dirty = true;
    state = STATE_IDLE;
    return;
  }
  Serial.println(" - Found our speed data char");

  if (pRemoteCharacteristic->canNotify()) {
    pRemoteCharacteristic->registerForNotify(notifyCallback);
  } else {
    Serial.println(" - But Cannot Notify?!?!");
    pClient->disconnect();
    dirty = true;
    state = STATE_IDLE;
    return;
  }
  state = STATE_CONNECTED;

  power_saving = true;
  digitalWrite(PIN_LED, HIGH);  //on M5Stick LOW turns on the LED, I want it OFF when connected and to blink when Searching for BLE
}

///////////////////////////////////////////////////////////////MAIN LOOP STARTS/////////////////////////////////////////
void loop() {

  ButtonA = 0;                  //reset
  currentMillis = millis();     // blink withhout delay while waiting to connect (no code blocking)
  currentMillisRun = millis();  // blink withhout delay while waiting to connect (no code blocking)

  //digitalWrite(PIN_LED, millis()%500>250);//  blinks LED when connected

  unsigned long now = seconds();

  if (!power_saving && !renderMenu && state != STATE_IDLE && (power_save_duration != 0) && (display_on_at + power_save_duration) < now) {
    display_on_at = seconds();
    power_saving = true;
  }

  button.tick();
  if (dirty) {
    if (power_saving) {
      display_on_at = seconds();
      power_saving = false;
    }
    if (renderMenu) {
      doRenderMenu();
    }
    dirty = false;
  }

  switch (state) {
    case STATE_IDLE:
      //digitalWrite(PIN_LED, LOW);


      if (!dirty) {
        renderSearching();
        do_scan();
      }
      break;
    case STATE_CONNECTING:
      connectToChrony();

      break;
    case STATE_CONNECTED:
      break;
    case STATE_READY:
      break;
  }

  M5.update();
  //press physical POWER ON/OFF button for more than 1 second but less then 6 sec (which is forced POWER-OFF) to restart ESP32 anytime
  if (M5.Axp.GetBtnPress() == 0x01) {  // 0x01 long press(1s), 0x02 press (momentary)
    esp_restart();                     //  Soft restart
  }

  //setCpuFrequencyMhz(160);  //80/160/240 mhz  do not go below 80mhz or it will not work

  pressBtnB();
  pressBtnA();
  pressBtnPower();

  if ((currentMillisRun - startMillisRun > poweroffInterval) && (M5.Axp.GetVBusVoltage() < 3)) {  //if times out AND BUS voltage is not enough to charge battery, then shutdown

    M5.Lcd.fillScreen(BLACK);
    M5.Lcd.setTextColor(RED);
    M5.Lcd.setTextSize(3);
    M5.Lcd.setCursor(0, 20);
    M5.Lcd.print("    Timed out:  ...shutdown");
    //M5.Lcd.print("Press front button to stop shutdown ");
    Serial.println("testing if power OFF (30s)");
    Serial.print("PIN INPUT VALUE ");
    Serial.println(PIN_INPUT);
    Serial.print("ButtonA (1 is on)");
    Serial.println(ButtonA);
    //  delay(30000);
    //reset shutdown timer and go back to connected menu
    // startMillisRun = currentMillisRun;  //
    //Serial.print("Should be reading 0 ");Serial.println(currentMillisRun - startMillisRun);
    poweroff();  //goes to shutdown
  }

}  ////////////////////////////////////////////////////////////MAIN LOOP ENDS//////////////////////////////////////////////

/* 
  Menu system
*/


static void sleepCallback(uint8_t param) {
  //Serial.printf("Good bye cruel world\n");

  powerstats();
}

static menuItem_t menu_sleep[] = {
  { "Stats", NULL, menu_sleep, NULL, NULL, sleepCallback, 0, NULL },
  // { "zzzz", NULL, menu_sleep, NULL, NULL, sleepCallback, 0, NULL },

};

void menuItemGenStringCurSleep(char* buffer) {
  sprintf(buffer, "[%s]", menu_sleep[0].menuString);
  Serial.println(buffer);
}

static const uint8_t power_save_duration_lut[] = { 0, 2, 5, 10 };

static void powerSaveCallback(uint8_t param) {
  if (power_save_duration != power_save_duration_lut[param]) {
    power_save_duration = power_save_duration_lut[param];
    EEPROM.write(4, power_save_duration);
    EEPROM.commit();
  }
  Serial.printf("Menu Item Selected PWR SAVE %d\n", power_save_duration);
  pCurrentMenuItem = menuStack[--menuStackIndex];
}

static menuItem_t menu_power_save[] = {
  { "Off", NULL, &menu_power_save[1], NULL, NULL, powerSaveCallback, 0, NULL },
  { "2s", NULL, &menu_power_save[2], NULL, NULL, powerSaveCallback, 1, NULL },
  { "5s", NULL, &menu_power_save[3], NULL, NULL, powerSaveCallback, 2, NULL },
  { "10s", NULL, &menu_power_save[0], NULL, NULL, powerSaveCallback, 3, NULL }
};

void menuItemGenStringCurPowerSaving(char* buffer) {
  uint8_t idx = 0;
  switch (power_save_duration) {
    case 2: idx = 1; break;
    case 5: idx = 2; break;
    case 10: idx = 3; break;
  }
  sprintf(buffer, "[%s]", menu_power_save[idx].menuString);
  Serial.println(buffer);
}

static void displayFlipCallback(uint8_t param) {
  display_flip = param;
  EEPROM.write(3, display_flip);
  EEPROM.commit();
  Serial.printf("Menu Item Selected DISPLAY_FLIP %d\n", display_flip);
  pCurrentMenuItem = menuStack[--menuStackIndex];
}

static menuItem_t menu_display_flip[] = {
  { "Off", NULL, &menu_display_flip[1], NULL, NULL, displayFlipCallback, DISPLAY_FLIP_OFF, NULL },
  { "On", NULL, &menu_display_flip[0], NULL, NULL, displayFlipCallback, DISPLAY_FLIP_ON, NULL }
};

void menuItemGenStringCurDisplayFlip(char* buffer) {
  sprintf(buffer, "[%s]", menu_display_flip[display_flip].menuString);
  Serial.println(buffer);
}

static void unitsCallback(uint8_t param) {
  units = param;
  EEPROM.write(1, units);
  EEPROM.commit();
  Serial.printf("Menu Item Selected UNITS %d\n", units);
  pCurrentMenuItem = menuStack[--menuStackIndex];
}

static menuItem_t menu_units[] = {
  { "FPS", NULL, &menu_units[1], NULL, NULL, unitsCallback, UNITS_IMPERIAL, NULL },
  { "M/S", NULL, &menu_units[0], NULL, NULL, unitsCallback, UNITS_METRIC, NULL }
};

void menuItemGenStringCurSelUnits(char* buffer) {
  sprintf(buffer, "[%s]", menu_units[units].menuString);
  Serial.println(buffer);
}

static void profileCallback(uint8_t param) {
  if (profile != param) {
    profile = param;
    EEPROM.write(2, profile);
    EEPROM.commit();
    profile_changed = true;
  }
  Serial.printf("Menu Item Selected PROFILE %d\n", profile);
  pCurrentMenuItem = menuStack[--menuStackIndex];
}

static menuItem_t menu_profile[] = {
  { "Bow/Airsoft", NULL, &menu_profile[1], NULL, NULL, profileCallback, PROFILE_BOW_AIRSOFT, NULL },
  { "CO2 Pistol", NULL, &menu_profile[2], NULL, NULL, profileCallback, PROFILE_CO2_PISTOL, NULL },
  { "Air Pistol", NULL, &menu_profile[3], NULL, NULL, profileCallback, PROFILE_AIR_PISTOL, NULL },
  { "Air Gun UK", NULL, &menu_profile[4], NULL, NULL, profileCallback, PROFILE_AIR_GUN_UK, NULL },
  { "Air Gun FAC", NULL, &menu_profile[0], NULL, NULL, profileCallback, PROFILE_AIR_GUN_FAC, NULL }
};

void menuItemGenStringCurSelProfile(char* buffer) {
  sprintf(buffer, "[%s]", menu_profile[profile].menuString);
  Serial.println(buffer);
}

static void sensitivityIncCallback(uint8_t param) {
  if (sensitivity <= 95) {
    sensitivity += 5;
    EEPROM.write(0, sensitivity);
    EEPROM.commit();
    Serial.printf("Menu Item Selected SENSITIVITY INC %d\n", sensitivity);
  }
}
static void sensitivityDecCallback(uint8_t param) {
  if (sensitivity >= 5) {
    sensitivity -= 5;
    EEPROM.write(0, sensitivity);
    EEPROM.commit();
    Serial.printf("Menu Item Selected SENSITIVITY DEC %d\n", sensitivity);
  }
}

static menuItem_t menu_sensitivity[] = {
  { "Increase", NULL, &menu_sensitivity[1], NULL, NULL, sensitivityIncCallback, 0, NULL },
  { "Decrease", NULL, &menu_sensitivity[0], NULL, NULL, sensitivityDecCallback, 0, NULL }
};

void menuItemGenStringSensitivity(char* buffer) {
  sprintf(buffer, "%d %%", sensitivity);
  Serial.println(buffer);
}

void menuItemGenStringCurSelSensitivity(char* buffer) {
  sprintf(buffer, "[%d %%]", sensitivity);
  Serial.println(buffer);
}


static menuItem_t menu_top_level[] = {
  { "Profile", NULL, &menu_top_level[1], menu_profile, menu_profile, NULL, 0, menuItemGenStringCurSelProfile },
  { "Min. Return", menuItemGenStringSensitivity, &menu_top_level[2], menu_sensitivity, menu_sensitivity, NULL, 0, menuItemGenStringCurSelSensitivity },
  { "Units", NULL, &menu_top_level[3], menu_units, menu_units, NULL, 0, menuItemGenStringCurSelUnits },
  { "Display Flip", NULL, &menu_top_level[4], menu_display_flip, menu_display_flip, NULL, 0, menuItemGenStringCurDisplayFlip },
  { "Dispay Timeout", NULL, &menu_top_level[5], menu_power_save, menu_power_save, NULL, 0, menuItemGenStringCurPowerSaving },
  { "Bat Stats", NULL, &menu_top_level[0], menu_sleep, menu_sleep, NULL, 0, menuItemGenStringCurSleep }

};

static menuItem_t menu_entry = { "Settings", NULL, menu_top_level, menu_top_level, NULL, NULL, 0, NULL };

void singleClick() {

  Serial.println("x1");
  Serial.print("PIN INPUT VALUE inside singleclick");
  Serial.println(PIN_INPUT);
  ButtonA = PIN_INPUT;
  if (renderMenu) {
    dirty = true;
    pCurrentMenuItem->currentSubMenu = pCurrentMenuItem->currentSubMenu->nextMenuItem;
  } else {
    if (power_saving) {
      display_on_at = seconds();
      power_saving = false;
    }
  }
}

void doubleClick() {
  if (renderMenu) {
    dirty = true;
    if (pCurrentMenuItem->currentSubMenu->menuItemCallback != NULL) {
      (*pCurrentMenuItem->currentSubMenu->menuItemCallback)(pCurrentMenuItem->currentSubMenu->param);
    } else {
      menuStack[menuStackIndex++] = pCurrentMenuItem;
      pCurrentMenuItem = pCurrentMenuItem->currentSubMenu;
    }
  }
  Serial.printf("x2 %d\n", menuStackIndex);
}

void longPressStop() {

  if (renderMenu) {
    if (menuStackIndex == 1) {
      renderMenu = false;

      M5.Lcd.fillScreen(BLACK);  //exit Menu
      M5.Lcd.setTextColor(GREEN);
      M5.Lcd.setTextSize(2);
      M5.Lcd.setCursor(50, 0);
      M5.Lcd.print("Connected");
      M5.Lcd.fillCircle(15, 15, 15, GREEN);

      M5.Lcd.setTextSize(2);
      M5.Lcd.setCursor(180, 0);
      M5.Lcd.setTextColor(WHITE);
      M5.Lcd.printf("%.2fv", M5.Axp.GetBatVoltage());
      M5.Lcd.setCursor(180, 18);
      //M5.Lcd.printf("%.2fv",clientBat) ;//FX Chrono battery,  (refresh every 3 mins?)
      if (clientBat > 0) {
        M5.Lcd.printf("%.2fv", clientBat);  //FX Chrono battery,  (refresh every 3 mins?)
      }
    //  M5.Lcd.setCursor(0, 50);
    //  M5.Lcd.printf("render menu/longpressStop loop");

      if (profile_changed) {
        pClient->disconnect();
        state = STATE_IDLE;
      }
    } else {
      dirty = true;
      pCurrentMenuItem = menuStack[--menuStackIndex];
    }
  } else if (state == STATE_CONNECTED) {
    profile_changed = false;
    dirty = true;
    renderMenu = true;
    pCurrentMenuItem = &menu_entry;
    menuStackIndex = 0;
    menuStack[menuStackIndex++] = pCurrentMenuItem;
  }
  Serial.printf("LPS %s %d\n", renderMenu ? "Menu On" : "Menu Off", menuStackIndex);
}


void powerstats() {  //battery, amps, ports, temp stats
  M5.update();

  while (digitalRead(PIN_INPUT) == 1) {  //wait until Button A is pressed and then exists menu

    tftSprite.setCursor(0, 0, 4);  // Set the cursor position and use the 4-point font.

    tftSprite.printf("Bat:  %.2fv  %.1fma\r\n", M5.Axp.GetBatVoltage(), M5.Axp.GetBatCurrent());  // Output voltage and current of BAT

    tftSprite.printf("Bat Pwr use: %.0fmw\r\n", M5.Axp.GetBatPower());  //runs only on BAT power, shows real-time power consumption

    tftSprite.printf("USB: %.2fv  %.1fma\r\n", M5.Axp.GetVBusVoltage(), M5.Axp.GetVBusCurrent());  // Output current and voltage of USB.

    tftSprite.printf("5V-in: %.2fv  %.1fma\r\n", M5.Axp.GetVinVoltage(), M5.Axp.GetVinCurrent());  // AUX 5V-in on GROVE port

    tftSprite.printf("Temp:  %.1fC \r\n", M5.Axp.GetTempInAXP192());  // Get the temperature of AXP192.

    tftSprite.pushSprite(0, 0);

    delay(1000);
  }

  M5.update();  // Detect whether the keystroke state has changed.
}


void poweroff() {
    //If on battery power AND no user input AND no shots then put it to sleep. (better to shut down complettely with Power ON/OFF button if not going to use it for a while)

  // esp_sleep_enable_timer_wakeup(SLEEP_MIN(30));  // 300 = 5 min, times 6 = 30 min OR we could always use the defined functions from the axp.h file!
  //esp_sleep_enable_timer_wakeup(1000000*60);  // code test mode, every 1 min. Use only for testing
  //M5.Axp.DeepSleep(SLEEP_MIN(1));

  Serial.println("Going to turn OFF now");

  // M5.Axp.SetSleep();
  //esp_deep_sleep_start();
  M5.Axp.PowerOff();  // complete power off,   WILL NOT WAKE UP, only with POWER button press
}

void pressBtnPower() {

  M5.update();
  //press physical POWER ON/OFF button for more than 1 second but less then 6 sec (which is forced POWER-OFF) to restart ESP32 anytime
  if (M5.Axp.GetBtnPress() == 0x02) {   // 0x01 long press(1s), 0x02 press (momentary)
    startMillisRun = currentMillisRun;  //
    Serial.print(currentMillisRun - startMillisRun);
    Serial.println(" <= time elapsed :   Power Button was short-pressed)");
  }
  M5.update();
  if (M5.Axp.GetBtnPress() == 0x01) {   // 0x01 long press(1s), 0x02 press (momentary)
    startMillisRun = currentMillisRun;  //
    Serial.print(currentMillisRun - startMillisRun);
    Serial.println(" <= time elapsed :   Power Button was long-pressed to restart(not yet enabled)");
    esp_restart();  //  Soft restart
  }
}


void pressBtnA() {

  M5.update();
  if (M5.BtnA.wasPressed()) {
    startMillisRun = currentMillisRun;  //
    Serial.print(currentMillisRun - startMillisRun);
    Serial.println("  <= time elapsed :  'A' Button was pressed)");
  }
}


void pressBtnB() {

  M5.update();
  if (M5.BtnB.wasPressed()) {
    startMillisRun = currentMillisRun;  //
    Serial.print(currentMillisRun - startMillisRun);
    Serial.println(" <= time elapsed :   'B' Button was pressed)");
  }
}
